
/**
 * Module dependencies.
 */

var express = require('express'),
    routes = require('./routes');

var app = module.exports = express.createServer();

var mongo = require('mongoskin');
var conn = mongo.db(process.env.MONGOLAB_URI || 'mongodb://localhost/db');

var http = require('http');
var url = require('url');

// Configuration

app.configure(function(){
  app.set('views', __dirname + '/views');
  app.set('view engine', 'jade');
  app.set('view options', {layout : false});
  app.use(express.bodyParser());
  app.use(express.methodOverride());
  app.use(express.cookieParser());
  app.use(express.session({ secret: 'your secret here' }));
  app.use(app.router);
  app.use(express.static(__dirname + '/public'));
});

app.configure('development', function(){
  app.use(express.errorHandler({ dumpExceptions: true, showStack: true }));
});

app.configure('production', function(){
  app.use(express.errorHandler());
});

// Routes
app.get('/', function(req, res) {
  res.render('index.jade',{
            locals: {
                user: 'jay',
                page_id: 'home'
            }
        });
});

app.get('/about', function(req, res) {
  res.render('about.jade', {
            locals: {
                user: 'jay',
                page_id: 'about'
            }
        });
});

app.get('/:user/display', function(req, res) {


  user = req.params.user;
  conn.collection('jay').distinct("item", function(err, items) {
     if (err) {
      console.log(err);
    }
    items.sort();
  res.render('display.jade', {
            locals: {

              items: JSON.stringify(items),
                user: req.params.user,
                page_id: 'display'
            }
        });
  });
});

app.get('/:user/entries', function(req, res) {
  user = req.params.user;
  conn.collection('jay').distinct("item", function(err, items) {
  conn.collection('jay').find().toArray(function(err, entrylist) {
    if (err) {
      console.log(err);
    }
    items.sort();

    res.render('entries.jade', {
            locals: {
                //entrylist: entrylist,
                user: req.params.user,
                items: JSON.stringify(items),
                page_id: 'entries'
            }
        });
    });
  });
});


app.get('/data', function(req, res) {
  var urlObj = url.parse(req.url, true);
  user = urlObj.query["user"];
  res.contentType('application/json');
  conn.collection(user).find().toArray(function(err, items) {
    if (err) {
      console.log(err);
    }
    items.forEach(function(element,index,array){element.time = element.time.valueOf();});
    res.send(JSON.stringify(items));
  });
});

app.post('/data', function(req, res){

    var timeStamp = new Date();
    var entry = { item : req.body.item, value: req.body.amount, time : timeStamp };
    console.log(req.body.item);
    console.log(req.body.amount);
    console.log(timeStamp.toString());

    conn.collection('jay').save(entry);
    res.send("OK");
});

var port = process.env.PORT || 3000;
app.listen(port, function() {
  console.log("Listening on " + port);
});