drawGraph(items[0]);





function drawGraph(item) {

var itemdata = [],
    totals = [],
    dates = [],
    dateTotals = [];

var height = 600,
    width = 720,
    padding = { verticle : 40, horizontal : 40 },
    stroke = 3;

var daytotals = [0,0,0,0,0,0,0],
    hourtotals = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
    weekviewData = [[0, 0, 0], [0, 1, 0], [0, 2, 0], [0, 3, 0], [0, 4, 0], [0, 5, 0], [0, 6, 0], [0, 7, 0], [0, 8, 0], [0, 9, 0], [0, 10, 0], [0, 11, 0], [0, 12, 0], [0, 13, 0], [0, 14, 0], [0, 15, 0], [0, 16, 0], [0, 17, 0], [0, 18, 0], [0, 19, 0], [0, 20, 0], [0, 21, 0], [0, 22, 0], [0, 23, 0], [1, 0, 0], [1, 1, 0], [1, 2, 0], [1, 3, 0], [1, 4, 0], [1, 5, 0], [1, 6, 0], [1, 7, 0], [1, 8, 0], [1, 9, 0], [1, 10, 0], [1, 11, 0], [1, 12, 0], [1, 13, 0], [1, 14, 0], [1, 15, 0], [1, 16, 0], [1, 17, 0], [1, 18, 0], [1, 19, 0], [1, 20, 0], [1, 21, 0], [1, 22, 0], [1, 23, 0], [2, 0, 0], [2, 1, 0], [2, 2, 0], [2, 3, 0], [2, 4, 0], [2, 5, 0], [2, 6, 0], [2, 7, 0], [2, 8, 0], [2, 9, 0], [2, 10, 0], [2, 11, 0], [2, 12, 0], [2, 13, 0], [2, 14, 0], [2, 15, 0], [2, 16, 0], [2, 17, 0], [2, 18, 0], [2, 19, 0], [2, 20, 0], [2, 21, 0], [2, 22, 0], [2, 23, 0], [3, 0, 0], [3, 1, 0], [3, 2, 0], [3, 3, 0], [3, 4, 0], [3, 5, 0], [3, 6, 0], [3, 7, 0], [3, 8, 0], [3, 9, 0], [3, 10, 0], [3, 11, 0], [3, 12, 0], [3, 13, 0], [3, 14, 0], [3, 15, 0], [3, 16, 0], [3, 17, 0], [3, 18, 0], [3, 19, 0], [3, 20, 0], [3, 21, 0], [3, 22, 0], [3, 23, 0], [4, 0, 0], [4, 1, 0], [4, 2, 0], [4, 3, 0], [4, 4, 0], [4, 5, 0], [4, 6, 0], [4, 7, 0], [4, 8, 0], [4, 9, 0], [4, 10, 0], [4, 11, 0], [4, 12, 0], [4, 13, 0], [4, 14, 0], [4, 15, 0], [4, 16, 0], [4, 17, 0], [4, 18, 0], [4, 19, 0], [4, 20, 0], [4, 21, 0], [4, 22, 0], [4, 23, 0], [5, 0, 0], [5, 1, 0], [5, 2, 0], [5, 3, 0], [5, 4, 0], [5, 5, 0], [5, 6, 0], [5, 7, 0], [5, 8, 0], [5, 9, 0], [5, 10, 0], [5, 11, 0], [5, 12, 0], [5, 13, 0], [5, 14, 0], [5, 15, 0], [5, 16, 0], [5, 17, 0], [5, 18, 0], [5, 19, 0], [5, 20, 0], [5, 21, 0], [5, 22, 0], [5, 23, 0], [6, 0, 0], [6, 1, 0], [6, 2, 0], [6, 3, 0], [6, 4, 0], [6, 5, 0], [6, 6, 0], [6, 7, 0], [6, 8, 0], [6, 9, 0], [6, 10, 0], [6, 11, 0], [6, 12, 0], [6, 13, 0], [6, 14, 0], [6, 15, 0], [6, 16, 0], [6, 17, 0], [6, 18, 0], [6, 19, 0], [6, 20, 0], [6, 21, 0], [6, 22, 0], [6, 23, 0]],
    total;

var filename = '/javascripts/daytum.csv';
var format = d3.time.format("%m/%y");

var xAxisLabel = function (d) {
  if (d === 12) { return "noon"; }
  if (d === 0) { return "midnight"; }
  if (d < 12) { return d; }
  return (d - 12);
};

var yAxisLabel = function (d) {
  if (d === 0) { return "Mon"; }
  if (d === 1) { return "Tue"; }
  if (d === 2) { return "Wed"; }
  if (d === 3) { return "Thr"; }
  if (d === 4) { return "Fri"; }
  if (d === 5) { return "Sat"; }
  if (d === 6) { return "Sun"; }
};





var viz = d3.select("#viz")
        .append("svg:svg")
        .attr("width", width)
        .attr("height", height)
        .attr("style", "background: #EEE");
      

var punches = viz.append("g")
        .attr("transform", "translate(" + 40 + "," + 40 + ")");

var graph = viz.append("g")
        .attr("transform", "translate(" + 40 + "," + 60 + ")");

var graph2 = viz.append("g")
        .attr("transform", "translate(" + (width - 60) + "," + 40 + ")");

var trendgraph = viz.append("g")
        .attr("transform", "translate(" + 40 + "," + (height - 300) + ")");



d3.csv(filename, function(data) {
    // Convert strings to numbers.
    data.forEach(function(d) {
    d.year = +d.year;
    d.month = +d.month;
    d.day = +d.day;
    d.hour = +d.hour;
    d.minute = +d.minute;
    d.second = +d.second;
    d['value'] = +d['value'];

    //If the it's the item we're looking for, push the values.
    if (d['item'] == item) {
      itemdata.push({date : new Date(d.year,d.month - 1,d.day,d.hour,d.minute,d.second), value : d['value']});
      daytotals[d.weekday] = daytotals[d.weekday] + d['value'];
      hourtotals[d.hour] = hourtotals[d.hour] + d['value'];
      weekviewData[d['hour'] + (d['weekday']*24)][2] +=  d['value'];
      }
    });

weekviewData.forEach(function(d) {
      totals.push(d[2]);
    });

total = d3.sum(totals);

itemdata.forEach(function(d) {
    dates.push({date : d3.time.day(d['date']), value : d['value']});
 });

//Awesome way to remove duplicate days and add their values!
var i = 0;
while( i < dates.length - 1) {
  if (dates[i]['date'].toDateString() == dates[i + 1]['date'].toDateString()) {
    dates[i]['value'] += dates[i + 1]['value'];
    dates.splice(i + 1,1);
  } else {
    i++;
  }
}

dates.forEach(function(d) {
  dateTotals.push(d['value']);
});

dates.reverse();


var rscale = d3.scale.linear()
     .domain([0, d3.max(totals)])
     .range([0, 12.5]);

var yscale = d3.scale.linear()
    .domain([0,6])
    .range([0, height - 400 - padding.verticle]);

var xscale = d3.scale.linear()
    .domain([0,23])
    .range([padding.horizontal, width -100 - padding.horizontal]);

var hbscale = d3.scale.linear()
    .domain([0, d3.max(hourtotals)])
    .range([0, 80]);

var dbscale = d3.scale.linear()
    .domain([0, d3.max(daytotals)])
    .range([0, 80]);

var daytrendxscale = d3.time.scale()
    .domain([dates[0]['date'], dates[dates.length - 1]['date']])
    .range([padding.horizontal, width - padding.horizontal]);

var daytrendyscale = d3.scale.linear()
    .domain([0, d3.max(dateTotals)])
    .range([0 - padding.verticle,100]);

                
var radius = function(d, i) {
        return rscale( d[2]);
    };
    
var ypos = function(d, i) {
        return yscale( d[0] );
    };

var xpos = function(d, i) {
    return xscale( d[1] );
};

var hbarheight = function (d, i) {
    return hbscale ( d );
};

var hbarypos = function (d, i) {
  return 280 - hbscale (d);
};

var hbarxpos = function (d, i) {
  return xscale ( i ) - 12.5;
};

var dbarwidth = function (d, i) {
  return dbscale ( d );
};

var dbarypos = function (d, i) {
  return yscale ( i ) - 12.5;
};

var daytrendxpos = function (d, i) {
  return daytrendxscale ( d );
};

var daytrendypos = function (d, i) {
  return -1 * daytrendyscale (d ) + 200;
};


var area = d3.svg.area()
    .x(function(d) { return daytrendxpos(d['date']); })
    .y0(200+padding.verticle)
    .y1(function(d) { return daytrendypos(d['value']); })
    .interpolate('linear');

var line = d3.svg.line()
    .x(function(d) { return daytrendxpos(d['date']); })
    .y(function(d) { return daytrendypos(d['value']); })
    .interpolate('linear');

punches.selectAll(".xrule")
        .data(d3.range(0, 24,2))
        .enter().append("text")
        .attr("class", "rule")
        .attr("x", xscale)
        .attr("y", 200)
        .attr("text-anchor", "middle")
        .attr("style", "font-size: 12; font-family: Helvetica, Arial, sans-serif")
        .attr("fill", "#888")
        .text(xAxisLabel);

punches.selectAll(".yrule")
        .data(d3.range(0, 7))
        .enter().append("text")
        .attr("class", "rule")
        .attr("x", 0)
        .attr("y", yscale)
        .attr("dy", "0.25em")
        .attr("text-anchor", "start")
        .attr("style", "font-size: 12; font-family: Helvetica, Arial, sans-serif")
        .attr("fill", "#888")
        .text(yAxisLabel);
        
punches.selectAll("circle")
        .data(weekviewData)
        .enter().append("circle")
        .attr("r", 0)
        .attr("cx", xpos)
        .attr("cy", ypos)
        .attr("fill", "#333")
        .style("stroke-width", stroke)
        .style("stroke", "EEE")
        .on("mouseover", function(d){ 
          d3.select(this).style("stroke", "lightblue");})
        .on("mouseout", function(d){ 
          d3.select(this).style("stroke", "#EEE");})
            .transition()
              .attr("r", radius)
              .duration(1000)
              .ease("quad-out");


graph.selectAll(".yrule")
        .data(hbscale.ticks(3))
        .enter().append("text")
        .attr("class", "rule")
        .attr("x", 0)
        .attr("y", hbarypos)
        .attr("dy", "0.25em")
        .attr("text-anchor", "start")
        .attr("style", "font-size: 12; font-family: Helvetica, Arial, sans-serif")
        .attr("fill", "#888")
        .text(String);

graph.selectAll("rect")
        .data(hourtotals)
        .enter().append("rect")
        .attr("x", hbarxpos)
        .attr("y", 280 )
        .attr("height", 0)
        .attr("width", 20)
        .attr("fill", "#333")
        .style("stroke-width", stroke)
        .style("stroke", "EEE")
        .on("mouseover", function(d){ 
          d3.select(this).style("stroke", "lightblue");})
        .on("mouseout", function(d){ 
          d3.select(this).style("stroke", "#EEE");})
      .transition()
        .attr("y", hbarypos)
        .attr("height", hbarheight)
        .duration(1000)
        .ease("quad-out");

graph2.selectAll(".xrule")
        .data(dbscale.ticks(3))
        .enter().append("text")
        .attr("class", "rule")
        .attr("x", dbscale)
        .attr("y", -20)
        .attr("dy", "0.25em")
        .attr("text-anchor", "middle")
        .attr("style", "font-size: 12; font-family: Helvetica, Arial, sans-serif")
        .attr("fill", "#888")
        .text(String);

graph2.selectAll("rect")
        .data(daytotals)
        .enter().append("rect")
        .attr("x", 0)
        .attr("y", dbarypos )
        .attr("height", 20)
        .attr("width", 0)
        .attr("fill", "#333")
        .style("stroke-width", stroke)
        .style("stroke", "#EEE")
        .on("mouseover", function(d){ 
          d3.select(this).style("stroke", "lightblue");})
        .on("mouseout", function(d){ 
          d3.select(this).style("stroke", "#EEE");})
      .transition()
        .attr("width", dbarwidth)
        .duration(1000)
        .ease("quad-out");


trendgraph.selectAll(".xrule")
        .data(daytrendxscale.ticks(10))
        .enter().append("text")
        .attr("class", "rule")
        .attr("x", daytrendxscale)
        .attr("y", padding.verticle + 240)
        .attr("dy", "0.25em")
        .attr("text-anchor", "start")
        .attr("style", "font-size: 12; font-family: Helvetica, Arial, sans-serif")
        .attr("fill", "#888")
        .text(function(d) {return format(d);});

trendgraph.selectAll(".yrule")
        .data(daytrendyscale.ticks(5))
        .enter().append("text")
        .attr("class", "rule")
        .attr("x", 0)
        .attr("y", daytrendypos)
        .attr("dy", "0.25em")
        .attr("text-anchor", "start")
        .attr("style", "font-size: 12; font-family: Helvetica, Arial, sans-serif")
        .attr("fill", "#888")
        .text(String);

trendgraph
        .data([dates])
        .append("svg:path")
        .style("fill", "#333")
        .attr("d", area)
        .on("mouseover", function(d){ 
          borderline.style("stroke", "lightblue")})
        .on("mouseout", function(d){ 
          borderline.style("stroke", "#EEE")});

var borderline = trendgraph
              .append("svg:path")
              .style("stroke", "#EEE")
              .style("stroke-width", stroke)
              .style("fill", "none")
              .attr("d", function(d) { return line(d) });


});
};
